----------------------------------------------------------------------
--preferences
----------------------------------------------------------------------

local options = renoise.Document.create {
  auto_max_enabled = false
}
renoise.tool().preferences = options


----------------------------------------------------------------------
--auto_max()
----------------------------------------------------------------------

function auto_max()

--enabled in DSP menu?
  if (options.auto_max_enabled.value) then 

    local selected_track = renoise.song().selected_track
    local selected_device_index = renoise.song().selected_device_index
   
    -- a device selected?
    if (selected_device_index ~= 0) then    
    -- from 2 so as not to try to minimize the mixer device
      for i = 2,#selected_track.devices do
        if (i == selected_device_index) then
         selected_track.devices[i].is_maximized = true
        else
         selected_track.devices[i].is_maximized = false

        end
      end
    end
  end
end

----------------------------------------------------------------------
--notifiers
----------------------------------------------------------------------


function start()  
renoise.song().selected_track_observable:add_notifier(auto_max) 
renoise.song().selected_device_observable:add_notifier(auto_max)
end  
    

renoise.tool().app_new_document_observable:add_notifier(start)


----------------------------------------------------------------------
--menu registration 
----------------------------------------------------------------------

renoise.tool():add_menu_entry {
  name = "DSP Device:Auto Maximize Selected Device",
  selected = function() return options.auto_max_enabled.value end,
  invoke = function() 
    options.auto_max_enabled.value = not options.auto_max_enabled.value 
  end
}


